Unit QSE1R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTQS11_p;

procedure QSE1R(var RINT :Array of Real; A :Real; B :Real; F :Func_F1;
                R :Real; E :Real; var N :Integer; var IERR :Integer);

implementation

procedure QSE1R(var RINT :Array of Real; A :Real; B :Real; F :Func_F1;
                R :Real; E :Real; var N :Integer; var IERR :Integer);
var
K,K1,M :Integer;
A1,A2,B1,B2,B3,C1,C2,C3,D1,D2,D3,E1,E2,E3,G1,G2,H,H1,H2,H3,PI,RM,RN,
   RP,RQ,RT,T,T1,T2,X,X0,X1,X2,Y :Real;
R1 :Array [0..9] of Real;
Z :Array [0..27] of Real;
const
NMAX :Integer = 1048576;
SYS001 :Real = 3.1415926535897932384626433832795;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130;
begin
N := Abs(N);
if ( N  =  0 ) 
 then goto _130;
IERR := 0;
PI := SYS001;
K1 := 0;
H := B - A;
if ( N  <  NMAX ) 
 then goto _10;
N := -1;
IERR := 65;
UTQS11(IERR,10);
goto _130;
_10:
Z[8] := R*A;
Z[9] := Cos(Z[8]);
Z[10] := Sin(Z[8]);
Z[12] := R*H;
Z[13] := Cos(Z[12]);
Z[14] := Sin(Z[12]);
R1[0] := F(A);
R1[5] := F(B);
_20:
H1 := 1.0/N;
H2 := H/N;
H3 := 32.0*N;
Z[0] := Z[12]/(2.0*N);
Z[27] := Abs(Z[0]);
if ( Z[27] - 0.25 ) < 0
 then goto _30
 else if ( Z[27] - 0.25 ) > 0
       then goto _100
       else goto _30;
_30:
Z[1] := Z[0]*Z[0];
Z[2] := Z[0]*Z[1];
Z[3] := Z[1]*Z[1];
Z[4] := Z[1]*Z[2];
Z[5] := Z[2]*Z[2];
Z[6] := Z[2]*Z[3];
Z[7] := Z[3]*Z[3];
A1 := Z[0]/3.0 + Z[2]/45.0 + 2.0*Z[4]/945.0 + Z[6]/4725.0;
B1 := -(1.0/3.0 + Z[1]/15.0 + 2.0*Z[3]/189.0 + Z[5]/675.0 + 2.0*Z[7]
    /10395.0);
C1 := -(Z[0]/15.0 + 4.0*Z[2]/189.0 + Z[4]/225.0 + 6763.0*Z[6]/
    8553600.0);
D1 := 1.0/45.0 + 4.0*Z[1]/189.0 + Z[3]/135.0 + 6071.0*Z[5]/
    3421440 + 8781007.0*Z[7]/25147584000.0;
E1 := 2.0*Z[0]/189.0 + Z[2]/135.0 + 9289.0*Z[4]/3421440.0 + 63967.0*
    Z[6]/78586200.0;
_40:
R1[1] := F(A+H2);
R1[2] := F(A+2.0*H2);
R1[3] := F(A+3.0*H2);
R1[4] := F(A+4.0*H2);
R1[6] := F(A+H*(1.0-H1));
R1[7] := F(A+H*(1.0-2.0*H1));
R1[8] := F(A+H*(1.0-3.0*H1));
R1[9] := F(A+H*(1.0-4.0*H1));
B2 := -25.0*R1[0]/12.0 + 4.0*R1[1] - 3.0*R1[2] + 4.0*R1[3]/3.0 -
    0.25*R1[4];
C2 := 35.0*R1[0]/12.0 - 26.0*R1[1]/3.0 + 9.5*R1[2] - 14.0*R1[3]
    /3.0 + 11.0*R1[4]/12.0;
D2 := -2.5*R1[0] + 9.0*R1[1] - 12.0*R1[2] + 7.0*R1[3] - 1.5*R1[4];
E2 := R1[0] - 4.0*R1[1] + 6.0*R1[2] - 4.0*R1[3] + R1[4];
B3 := 25.0*R1[5]/12.0 - 4.0*R1[6] + 3.0*R1[7] - 4.0*R1[8]/3.0 +
    0.25*R1[9];
C3 := 35.0*R1[5]/12.0 - 26.0*R1[6]/3.0 + 9.5*R1[7] - 14.0*R1[8]
    /3.0 + 11.0*R1[9]/12.0;
D3 := 2.5*R1[5] - 9.0*R1[6] + 12.0*R1[7] - 7.0*R1[8] + 1.5*R1[9];
E3 := R1[5] - 4.0*R1[6] + 6.0*R1[7] - 4.0*R1[8] + R1[9];
RM := (B1*B2 + D1*D2/4.0)/2.0;
RN := (C1*C2 + E1*E2/4.0)/4.0;
RP := (B1*B3 + D1*D3/4.0)/2.0;
RQ := (C1*C3 + E1*E3/4.0)/4.0;
X := (R1[0] - RM + (A1*R1[5] + RQ)*Z[14] + (R1[5] + RP)*
    Z[13])/2.0;
Y := (A1*R1[0] + RN + (R1[5] + RP)*Z[14] - (A1*R1[5] + RQ)*
    Z[13])/2.0;
M := N - 5;
Z[11] := Z[12]/N;
X := X + R1[1]*Cos(Z[11]) + R1[2]*Cos(2.0*Z[11]) + R1[3]
    *Cos(3.0*Z[11]) + R1[4]*Cos(4.0*Z[11]) + R1[9]*Cos((N-4.0)*
    Z[11]) + R1[8]*Cos((N-3.0)*Z[11]) + R1[7]*Cos((N-2.0)*Z[11]
    ) + R1[6]*Cos((N-1.0)*Z[11]);
Y := Y + R1[1]*Sin(Z[11]) + R1[2]*Sin(2.0*Z[11]) + R1[3]
    *Sin(3.0*Z[11]) + R1[4]*Sin(4.0*Z[11]) + R1[9]*Sin((N-4.0)*
    Z[11]) + R1[8]*Sin((N-3.0)*Z[11]) + R1[7]*Sin((N-2.0)*Z[11]
    ) + R1[6]*Sin((N-1.0)*Z[11]);
for K:=5 to M do
 begin
  A2 := F(A+H2*K);
  X := X + A2*Cos(Z[11]*K);
  Y := Y + A2*Sin(Z[11]*K);
_50:
 end;
RINT[0] := (X*Z[9] - Y*Z[10])*H2;
RINT[1] := (Y*Z[9] + X*Z[10])*H2;
T1 := (E1*E3*Z[14])/H3;
T2 := (E1*E2 - E1*E3*Z[13])/H3;
T := Sqrt(IntPower(T1,2)+IntPower(T2,2));
if ( E ) < 0
 then goto _130
 else if ( E ) > 0
       then goto _70
       else goto _130;
_60:
if ( T - E ) < 0
 then goto _130
 else if ( T - E ) > 0
       then goto _80
       else goto _130;
_70:
K1 := K1 + 1;
if ( K1 - 1 ) < 0
 then goto _90
 else if ( K1 - 1 ) > 0
       then goto _90
       else goto _60;
_80:
G1 := RINT[0];
G2 := RINT[1];
N := 2*N;
if ( N  <  NMAX ) 
 then goto _20;
N := -1;
IERR := 65;
UTQS11(IERR,10);
goto _130;
_90:
RT := Sqrt(IntPower(RINT[0]-G1,2) + IntPower(RINT[1] - G2,2));
if ( EMin1(T,RT) - E ) < 0
 then goto _130
 else if ( EMin1(T,RT) - E ) > 0
       then goto _80
       else goto _130;
_100:
X0 := Z[27]/PI;
X1 := Trunc(X0+0.5);
X2 := Trunc(X0);
if ( Abs(X0-X1) - 1.0/(4.0*PI) ) < 0
 then goto _110
 else if ( Abs(X0-X1) - 1.0/(4.0*PI) ) > 0
       then goto _120
       else goto _110;
_110:
N := Trunc( Trunc(Abs(Z[12]/(2.0*PI*(X2-0.5)))) );
if ( N  <  NMAX ) 
 then goto _20;
N := -1;
IERR := 65;
UTQS11(IERR,10);
goto _130;
_120:
Z[15] := 1.0/Z[0];
Z[16] := Z[15]*Z[15];
Z[17] := Z[15]*Z[16];
Z[18] := Z[16]*Z[16];
Z[19] := Z[15]*Z[18];
Z[20] := Sin(Z[0]);
Z[21] := Z[20]*Z[20];
Z[22] := Z[20]*Z[21];
Z[23] := Z[21]*Z[21];
Z[24] := Z[20]*Z[23];
Z[25] := Cos(Z[0]);
Z[26] := Z[25]*Z[25];
A1 := Z[15] - Z[25]/Z[20];
B1 := Z[16] - 1.0/Z[21];
C1 := Z[25]/Z[22] - Z[17];
D1 := (1.0 + 2.0*Z[26])/(3.0*Z[23]) - Z[18];
E1 := Z[19] - Z[25]*(2.0 + Z[26])/(3.0*Z[24]);
goto _40;
_130:
end;

end.
